Assignee: Greg Sutcliffe   

Category: External Nodes   
Difficulty:  Fixed in Releases:  
Bugzilla link:  Red Hat JIRA:  

Pull request:    

Description

Sometimes you want to pass information that Foreman knows (such as hostnames, IPs, MACs, subnets, etc) to Puppet through the

ENC. At present it is not possible to do

parameters:

  test: '<%= @host.name %>'

 or

classes:

  puppet:

    certname: '<%= @host.certname %>'

 Foreman will simply send this static string to Puppet. It would be nice to be able to send dynamic data to Puppet via ERB, just like we

do in the templates.

Related issues:

Related to Foreman - Feature #1107: variables in settings Closed 08/11/2011

Associated revisions

Revision 84ae9603 - 09/09/2013 02:33 PM - Greg Sutcliffe

fixes #2260 Allow ERB in ENC global / class parameters

Adds code to parse the global & class parameters, and adds a setting (default true)

to disable this if needed. Also has some tests.

History

#1 - 09/09/2013 02:38 PM - Ohad Levy

- Description updated

- Target version set to 1.3.0

#2 - 09/09/2013 03:31 PM - Greg Sutcliffe

- Status changed from Assigned to Closed

- % Done changed from 0 to 100

Applied in changeset 84ae9603d480bfe88b722cde8d91c9bb10b88be6.

#3 - 10/18/2013 07:58 AM - Dominic Cleal

- Related to Feature #1107: variables in settings added

#4 - 11/03/2013 10:42 PM - Glen Ogilvie

This looks like what I am looking for, but don't seem to be able to do everything I would expect, like:
classes:

  envtest:

    two: <%= scope.lookupvar(envtest::params::one) %>

 or

classes:

  envtest:

    two: '<%= @envtest::params::one) %>'

 Should ERB functions work?  and should it be possible to lookup other variables set in Foreman, rather than just facts?

#5 - 11/04/2013 09:06 AM - Dominic Cleal

There's a difference between ERB templating in Foreman and in Puppet, as it changes what variables you'll have access to.  This feature allows for

interpolation as per TemplateWriting in Foreman, which is long before Puppet classes and parameters are available.  You won't be able to reference

any Puppet ERB functionality from Foreman.
